//
//  ShowPhoto.m
//  MyData
//
//  Created by Stefano on 28/02/17.
//  Copyright © 2017 RWS. All rights reserved.
//

#import "ShowPhoto.h"
#import "keepGoingPhoto.h"

@interface ShowPhoto (){
    //Audio settings
    AVAudioRecorder *recorder;
    AVAudioPlayer *player;
}

@end

@implementation ShowPhoto


@synthesize imageView;

@synthesize introShowName;
@synthesize introShowType;
@synthesize introShowUrl;
@synthesize introShowPathPhoto;
@synthesize introShowPathAudio;
@synthesize introShowDescr;

@synthesize showName;
@synthesize showType;
@synthesize showDescr;


@synthesize playButton;



- (void)viewDidLoad {
    [super viewDidLoad];
    
    //Setting the UITextFields
    [showName setText:introShowName];
    [showType setText:introShowType];
    [showDescr setText:introShowDescr];
    
    //Setting the image
    UIImage *image = [UIImage imageWithContentsOfFile:introShowPathPhoto];
    [imageView setImage:image];
    
    //From NSString to NSURL for path_audio
    NSURL *outputFileURL = [NSURL URLWithString:introShowPathAudio];
    player = [[AVAudioPlayer alloc] initWithContentsOfURL:outputFileURL error:nil];
    
    // Setup audio session
    AVAudioSession *session = [AVAudioSession sharedInstance];
    [session setCategory:AVAudioSessionCategoryPlayAndRecord error:nil];
}


- (IBAction)playTapped:(id)sender {
    [player play];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}




    //Send path_photo to keepGoingPhoto for show a bigger image
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    if ([segue.identifier isEqualToString:@"sendPhoto"]) {
        keepGoingPhoto *controller = segue.destinationViewController;
        controller.introShowPathPhoto = introShowPathPhoto;
    }
}


@end
