//
//  ViewController.m
//  MyData
//
//  Created by Stefano on 28/02/17.
//  Copyright © 2017 RWS. All rights reserved.
//
//
#import "ViewController.h"
#import <QuartzCore/QuartzCore.h>

int k=0;
NSArray *pathComponents;
NSURL *outputFileURL;
NSString *myString;


@interface ViewController (){
AVAudioRecorder *recorder;
AVAudioPlayer *player;
}


@end

NSString * myDB;

@implementation ViewController

@synthesize name;
@synthesize type;
@synthesize url;
@synthesize path_photo;
@synthesize descr;

@synthesize descript;


@synthesize introUrl;//mi serve per passare l'url tra i due controller
@synthesize introPhoto;//mi serve per passare il path_photo tra i due controller
@synthesize introType;//mi serve per passare il tipo tra i due controller


@synthesize stopButton, playButton, recordPauseButton;//for audio

- (void)viewDidLoad
{
    [super viewDidLoad];

    //Set the TextView's border
    [[self.descr layer] setBorderColor:[[UIColor lightGrayColor] CGColor]];
    [[self.descr layer] setBorderWidth:0.3];
    [[self.descr layer] setCornerRadius:5];
    
    
//    [[self.descript layer] setBorderColor:[[UIColor lightGrayColor] CGColor]];
//    [[self.descript layer] setBorderWidth:2.2];
//    [[self.descript layer] setCornerRadius:5];
    
    //Make a "fake" placeholder
    descr.text = @"Description";
    descr.textColor = [UIColor lightGrayColor];
    descr.delegate = self;
    

    [url setText:introUrl];
    [path_photo setText:introPhoto];
    [type setText:introType];

    myDB= @"myNote2.db";
    
    // Disable Stop/Play button when application launches
    [stopButton setEnabled:NO];
    [playButton setEnabled:NO];
    
    // Set the audio name that changes every time a new one is made
    NSString *audio1 = @"myAudio";
    NSString *audio3 = @".m4a";
    NSString * audio2=  [NSString stringWithFormat:@"%@%d%@",audio1,k, audio3];
    k++;
    
    pathComponents = [NSArray arrayWithObjects:[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject],audio2,nil];
    outputFileURL = [NSURL fileURLWithPathComponents:pathComponents];
    myString = outputFileURL.absoluteString;

    // Setup audio session
    AVAudioSession *session = [AVAudioSession sharedInstance];
    [session setCategory:AVAudioSessionCategoryPlayAndRecord error:nil];
    
    // Define the recorder setting
    NSMutableDictionary *recordSetting = [[NSMutableDictionary alloc] init];
    
    [recordSetting setValue:[NSNumber numberWithInt:kAudioFormatMPEG4AAC] forKey:AVFormatIDKey];
    [recordSetting setValue:[NSNumber numberWithFloat:44100.0] forKey:AVSampleRateKey];
    [recordSetting setValue:[NSNumber numberWithInt: 2] forKey:AVNumberOfChannelsKey];
    
    // Initiate and prepare the recorder
    recorder = [[AVAudioRecorder alloc] initWithURL:outputFileURL settings:recordSetting error:NULL];
    recorder.delegate = self;
    recorder.meteringEnabled = YES;
    [recorder prepareToRecord];

}

    //Still about the "fake" placeholder
- (BOOL) textViewShouldBeginEditing:(UITextView *)textView
{
    descr.text = @"";
    descr.textColor = [UIColor blackColor];
    return YES;
}
-(void) textViewDidChange:(UITextView *)textView
{
    if(descr.text.length == 0){
        descr.textColor = [UIColor lightGrayColor];
        descr.text = @"Description";
        [descr resignFirstResponder];
    }
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}


- (IBAction)recordPauseTapped:(id)sender {
    // Stop the audio player before recording
    if (player.playing) {
        [player stop];
    }
    if (!recorder.recording) {
        AVAudioSession *session = [AVAudioSession sharedInstance];
        [session setActive:YES error:nil];
        
        // Start recording
        [recorder record];
    } else {
        [recorder pause];
    }
    [stopButton setEnabled:YES];
    [playButton setEnabled:NO];
}

- (IBAction)stopTapped:(id)sender {
    [recorder stop];
    AVAudioSession *audioSession = [AVAudioSession sharedInstance];
    [audioSession setActive:NO error:nil];
}


- (void) audioRecorderDidFinishRecording:(AVAudioRecorder *)avrecorder successfully:(BOOL)flag{
    [stopButton setEnabled:NO];
    [playButton setEnabled:YES];
}



- (IBAction)playTapped:(id)sender {
    if (!recorder.recording){
        player = [[AVAudioPlayer alloc] initWithContentsOfURL:outputFileURL error:nil];
        [player setDelegate:self];
        [player play];
    }
}


- (void) audioPlayerDidFinishPlaying:(AVAudioPlayer *)player successfully:(BOOL)flag{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle: @"Done"
                                                    message: @"Finish playing the recording!"
                                                   delegate: nil
                                          cancelButtonTitle:@"OK"
                                          otherButtonTitles:nil];
    [alert show];
}


- (IBAction)addData:(id)sender {
    [self saveUserInDatabase];
}



-(void)saveUserInDatabase { //========================SAVE==============================
    
    // Copy the database if needed
    [self createEditableCopyOfDatabaseIfNeeded];
    
    NSString *filePath = [self getWritableDBPath];
    
    sqlite3 *database;
    NSString * theN=name.text;
    NSString * theT=introType;
    NSString * theU=introUrl;
    NSString * thePP=introPhoto;
    NSString * thePA=myString;
    NSString * theD=descr.text;
    
    if(sqlite3_open([filePath UTF8String], &database) == SQLITE_OK) {
        
        const char *sqlStatement = "insert into myTable (name,type,url,path_photo,path_audio,descr) VALUES (?,?,?,?,?,?)";
        sqlite3_stmt *compiledStatement;
        if(sqlite3_prepare_v2(database, sqlStatement, -1, &compiledStatement, NULL) == SQLITE_OK)    {
            sqlite3_bind_text( compiledStatement, 1,[theN UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_text( compiledStatement, 2,[theT UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_text( compiledStatement, 3,[theU UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_text( compiledStatement, 4,[thePP UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_text( compiledStatement, 5,[thePA UTF8String], -1, SQLITE_TRANSIENT);
            sqlite3_bind_text( compiledStatement, 6,[theD UTF8String], -1, SQLITE_TRANSIENT);
            
        }
        if(sqlite3_step(compiledStatement) != SQLITE_DONE ) {
            NSLog( @"Save Error: %s", sqlite3_errmsg(database) );
        }
        sqlite3_finalize(compiledStatement);
    }
    sqlite3_close(database);
}

//========================================WRITABLE DATABSE PATH=======================
- (NSString *) getWritableDBPath {
    
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory , NSUserDomainMask, YES);
    NSString *documentsDir = [paths objectAtIndex:0];
    return [documentsDir stringByAppendingPathComponent:myDB];
    
}

//================================================Copies database to appropriate location============

-(void)createEditableCopyOfDatabaseIfNeeded
{
    // Testing for existence
    BOOL success;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSError *error;
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,
                                                         NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    NSString *writableDBPath = [documentsDirectory stringByAppendingPathComponent:myDB];
    
    success = [fileManager fileExistsAtPath:writableDBPath];
    if (success)
        return;
    
    // The writable database does not exist, so copy the default to
    // the appropriate location.
    NSString *defaultDBPath = [[[NSBundle mainBundle] resourcePath]
                               stringByAppendingPathComponent:myDB];
    success = [fileManager copyItemAtPath:defaultDBPath
                                   toPath:writableDBPath
                                    error:&error];
    if(!success)
    {
        NSAssert1(0,@"Failed to create writable database file with Message : '%@'.",
                  [error localizedDescription]);
    }
}

@end
